



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>jQuery之ajax实现篇</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">jQuery之ajax实现篇</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 15:51:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　<strong>jQuery的ajax方法非常好用，这么好的东西，你想拥有一个属于自己的ajax么？接下来，我们来自己做一个简单的ajax吧。</strong></p>
<h2>实现功能</h2>
<p>由于jq中的ajax方法是用了内置的deferred模块，是Promise模式的一种实现，而我们这里没有讲过，所以我们就不使用这一模式啦。</p>
<p>我们只定义一个ajax方法，他可以简单的get，post，jsonp请求就可以啦~~</p>
<div>
<pre class="prettyprint linenums">var ajax = function () {

  //  做一些初始化，定义一些私有函数等

  return function () {<br />
    // ajax主体代码<br />
  }

}()

ajax({<br />
  url: myUrl,<br />
  type: 'get',<br />
  dataType: 'json',<br />  timeout: 1000,<br />
  success: function (data, status) {<br />
    console.log(data)<br />
  },<br />
  fail: function (err, status) {<br />
    console.log(err)<br />
  }<br />
})</pre>
</div>
<p>我们的ajax方法最后实现的功能如上所示，非常类似于jq。那我们还在等什么，开始吧。</p>
<h2>整体思路</h2>
<p>我们的ajax方法需要传递一个对象进去，这个对象中我们可以定义一些我们希望的属性，我们就必须初始一下各种属性</p>
<div>
<pre class="prettyprint linenums">//默认请求参数<br />
  var _options = {<br />
    url: null,  // 请求连接<br />
    type: 'GET',  // 请求类型<br />
    data: null,  // post时请求体<br />
    dataType: 'text',  // 返回请求的类型，有text/json两种<br />
    jsonp: 'callback',  // jsonp请求的标志，一般不改动<br />
    jsonpCallback: 'jsonpCallback',  //jsonp请求的函数名<br />
    async: true,   // 是否异步<br />
    cache: true,   // 是否缓存<br />
    timeout:null,  // 设置请求超时<br />
    contentType: 'application/x-www-form-urlencoded',<br />
    success: null,  // 请求成功回调函数<br />
    fail: null   // 请求失败回调<br />
  }</pre>
</div>
<p>以上我们定义了一大串请求有关的数据，接下来我们就开始ajax主体函数的书写，现在的ajax方法是这样了</p>
<div>
<pre class="prettyprint linenums">var ajax = function () {

  //默认请求参数<br />
  var _options = {<br />
    url: null,<br />
    type: 'GET',<br />
    data: null,<br />
    dataType: 'text',<br />
    jsonp: 'callback',<br />
    jsonpCallback: 'jsonpCallback',<br />
    async: true,<br />
    cache: true,<br />
    timeout:null,<br />
    contentType: 'application/x-www-form-urlencoded',<br />
    success: null,<br />
    fail: null<br />
  }<br />
  // ...<br />
  return function (options) {<br />
     // ...<br />
  }<br />
}()</pre>
</div>
<p>我们可以想一下，ajax方法传递一个对象进来，我们是不是需要把我们设置的这个对象上的属性来覆盖掉初始化_options上面的那些属性呢，肯定需要。那下面我们先写一个简单的继承，如下：</p>
<div>
<pre class="prettyprint linenums">var ajax = function () {

  //默认请求参数<br />
  var _options = {<br />
    url: null,<br />
    type: 'GET',<br />
    data: null,<br />
    dataType: 'text',<br />
    jsonp: 'callback',<br />
    jsonpCallback: 'jsonpCallback',<br />
    async: true,<br />
    cache: true,<br />
    timeout:null,<br />
    contentType: 'application/x-www-form-urlencoded',<br />
    success: null,<br />
    fail: null<br />
  }<br />
  <strong>//  内部使用的继承方法<br />
  var _extend = function(target,options) {<br />
    if( typeof target !== 'object' || typeof options !== 'object' ) {<br />
      return;<br />
    }<br />
    var copy ,clone, name;<br />
    for( name in options ) {<br />
      if(options.hasOwnProperty(name) &amp;&amp; !target.hasOwnProperty(name)) {<br />
        target[name] = options[name];<br />
      }<br />
    }<br />
    return target;<br />
  };

  </strong>// ...<br />
  return function (options) {

    // 没有传参或者没有url，抛出错误<br />
    if( !options || !options.url ) {<br />
      throw('参数错误！');<br />
    }

    // 继承操作<br />
    options.type = options.type.toUpperCase();<br />
    _extend(options,_options);<br />
     // ...<br />
  }<br />
}()</pre>
</div>
<p>这个继承方法，我们是把初始化的_options继承到了options，为什么呢？因为我们这个_options对象不在ajax方法内部，我们需要使用它，但我们不能改变他，如果改变了他，下一次使用ajax方法将会崩溃。因此，我们紧紧是把配置的options对象没有的属性设置为初始值。</p>
<p>下面，我们就要发送请求了么？等等！好像jsonp请求不是xhr请求啊，他好像是将请求url当做script标签的src值插入到页面body中去实现的，哦，对了，我们先把jsonp请求处理一下再开始建立xhr请求的代码吧。</p>
<div>
<pre class="prettyprint linenums">var ajax = function () {

  //默认请求参数<br />
  var _options = {<br />
    url: null,<br />
    type: 'GET',<br />
    data: null,<br />
    dataType: 'text',<br />
    jsonp: 'callback',<br />
    jsonpCallback: 'jsonpCallback',<br />
    async: true,<br />
    cache: true,<br />
    timeout:null,<br />
    contentType: 'application/x-www-form-urlencoded',<br />
    success: null,<br />
    fail: null<br />
  }<br />
  //  内部使用的继承方法<br />
  var _extend = function(target,options) {<br />
    if( typeof target !== 'object' || typeof options !== 'object' ) {<br />
      return;<br />
    }<br />
    var copy ,clone, name;<br />
    for( name in options ) {<br />
      if(options.hasOwnProperty(name) &amp;&amp; !target.hasOwnProperty(name)) {<br />
        target[name] = options[name];<br />
      }<br />
    }<br />
    return target;<br />
  };

  // jsonp处理函数<br />
  function _sendJsonpRequest(url,callbackName,succCallback) {

    var script = document.createElement('script');

    script.type="text/javascript";<br />
    script.src=url;

    document.body.appendChild(script);<br />
    // 如果用户自己定义了回调函数，就用自己定义的，否则，调用success函数<br />
    window[callbackName] = window[callbackName] || succCallback;

  }

  // ...<br />
  return function (options) {

    // 没有传参或者没有url，抛出错误<br />
    if( !options || !options.url ) {<br />
      throw('参数错误！');<br />
    }

    // 继承操作<br />
    options.type = options.type.toUpperCase();<br />
    _extend(options,_options);

    /*jsonp部分，直接返回*/<br />
    if( options.dataType === 'jsonp' ) {<br />
      var jsonpUrl = options.url.indexOf('?') &gt; -1 ? options.url: options.url +<br />
        '?' + options.jsonp+ '=' + options.jsonpCallback;

     return  _sendJsonpRequest(jsonpUrl,options.jsonpCallback,options.success);

    }<br />
     // ...<br />
  }<br />
}()</pre>
</div>
<p>我们定义了一个_sendJsonpRequest函数，这个函数接收三个参数，第一个是jsonpUrl，第二个是jsonp的回调函数名，第三个是成功回调函数，我们在这个函数内建立一个src为jsonpUrl的script元素插入到body中，同时，确定了回调函数（如果我们定义了jsonpCallback函数就调用它，如果没有就调用success回调，一般情况我们不去定义全局的jsonpCallback函数而传递success回调来完成jsonp请求）。</p>
<p>好，处理好jsonp请求后，我们开始处理xhr请求了。</p>
<div>
<pre class="prettyprint linenums">var ajax = function () {

  //默认请求参数<br />
  var _options = {<br />
    url: null,<br />
    type: 'GET',<br />
    data: null,<br />
    dataType: 'text',<br />
    jsonp: 'callback',<br />
    jsonpCallback: 'jsonpCallback',<br />
    async: true,<br />
    cache: true,<br />
    timeout:null,<br />
    contentType: 'application/x-www-form-urlencoded',<br />
    success: null,<br />
    fail: null<br />
  }<br />
  //  内部使用的继承方法<br />
  var _extend = function(target,options) {<br />
    if( typeof target !== 'object' || typeof options !== 'object' ) {<br />
      return;<br />
    }<br />
    var copy ,clone, name;<br />
    for( name in options ) {<br />
      if(options.hasOwnProperty(name) &amp;&amp; !target.hasOwnProperty(name)) {<br />
        target[name] = options[name];<br />
      }<br />
    }<br />
    return target;<br />
  };

  // jsonp处理函数<br />
  function _sendJsonpRequest(url,callbackName,succCallback) {

    var script = document.createElement('script');

    script.type="text/javascript";<br />
    script.src=url;

    document.body.appendChild(script);<br />
    // 如果用户自己定义了回调函数，就用自己定义的，否则，调用success函数<br />
    window[callbackName] = window[callbackName] || succCallback;

  }

  // json转化为字符串<br />
  var _param = function(data) {<br />
    var str = '';<br />
    if( !data || _empty(data)) {<br />
      return str;<br />
    }<br />
    for(var key in data) {<br />
      str += key + '='+ data[key]+'&amp;'<br />
    }<br />
    str = str.slice(0,-1);<br />
    return str;<br />
  }<br />
  //判断对象是否为空<br />
  var _empty = function(obj) {<br />
    for(var key in obj) {<br />
      return false;<br />
    }<br />
    return true;<br />
  }

  // ...<br />
  return function (options) {

    // 没有传参或者没有url，抛出错误<br />
    if( !options || !options.url ) {<br />
      throw('参数错误！');<br />
    }

    // 继承操作<br />
    options.type = options.type.toUpperCase();<br />
    _extend(options,_options);

    /*jsonp部分，直接返回*/<br />
    if( options.dataType === 'jsonp' ) {<br />
      var jsonpUrl = options.url.indexOf('?') &gt; -1 ? options.url: options.url +<br />
        '?' + options.jsonp+ '=' + options.jsonpCallback;

     return  _sendJsonpRequest(jsonpUrl,options.jsonpCallback,options.success);

    }

     //XMLHttpRequest传参无影响<br />
    var xhr = new (window.XMLHttpRequest || ActiveXObject)('Microsoft.XMLHTTP');<br />
    // get搜索字符串<br />
    var search = '';

    // 将data序列化<br />
    var param= _param(options.data)

    if( options.type === 'GET' ) {<br />
      search = (options.url.indexOf('?') &gt; -1 ? '&amp;' : '?') + param;<br />
      if(!options.cache) {<br />
        search += '&amp;radom='+Math.random();<br />
      }

      param = null;<br />
    }

     // ...<br />
  }<br />
}()</pre>
</div>
<p>首先，兼容ie创建xhr对象，XMLHttpRequest构造函数传递参数是无影响，然后我们定义了两个辅助变量：search、param，前者用于get请求的查询字串，后者用于post请求的send内容，我们定义了一个_param方法来讲对象转换为send方法参数的模式，就如你看到的那样，下面我们做了get与post之间合理的search、param的赋值工作。接下来我们就可以发送请求书写最激动人心的内容了。</p>
<p>最终的代码如下</p>
<div>
<pre class="prettyprint linenums">;

var ajax = function () {

  //默认请求参数<br />
  var _options = {<br />
    url: null,<br />
    type: 'GET',<br />
    data: null,<br />
    dataType: 'text',<br />
    jsonp: 'callback',<br />
    jsonpCallback: 'jsonpCallback',<br />
    async: true,<br />
    cache: true,<br />
    timeout:null,<br />
    contentType: 'application/x-www-form-urlencoded',<br />
    success: null,<br />
    fail: null<br />
  }

  // json转化为字符串<br />
  var _param = function(data) {<br />
    var str = '';<br />
    if( !data || _empty(data)) {<br />
      return str;<br />
    }<br />
    for(var key in data) {<br />
      str += key + '='+ data[key]+'&amp;'<br />
    }<br />
    str = str.slice(0,-1);<br />
    return str;<br />
  }<br />
  //判断对象是否为空<br />
  var _empty = function(obj) {<br />
    for(var key in obj) {<br />
      return false;<br />
    }<br />
    return true;<br />
  }

  var _extend = function(target,options) {<br />
    if( typeof target !== 'object' || typeof options !== 'object' ) {<br />
      return;<br />
    }<br />
    var copy ,clone, name;<br />
    for( name in options ) {<br />
      if(options.hasOwnProperty(name) &amp;&amp; !target.hasOwnProperty(name)) {<br />
        target[name] = options[name];<br />
      }<br />
    }<br />
    return target;<br />
  };

  // 自定义text转化json格式<br />
  var parseJSON = function(text) {<br />
    if(typeof text !== 'string') {<br />
      return;<br />
    }<br />
    if( JSON &amp;&amp; JSON.parse ) {<br />
      return JSON.parse(text);<br />
    }<br />
    return (new Function('return '+text))();<br />
  }

  // jsonp处理函数<br />
  function _sendJsonpRequest(url,callbackName,succCallback) {

    var script = document.createElement('script');

    script.type="text/javascript";<br />
    script.src=url;

    document.body.appendChild(script);<br />
    // 如果用户自己定义了回调函数，就用自己定义的，否则，调用success函数<br />
    window[callbackName] = window[callbackName] || succCallback;

  }

  return function (options) {

    // 没有传参或者没有url，抛出错误<br />
    if( !options || !options.url ) {<br />
      throw('参数错误！');<br />
    }

    // 继承操作<br />
    options.type = options.type.toUpperCase();<br />
    _extend(options,_options);

    /*jsonp部分，直接返回*/<br />
    if( options.dataType === 'jsonp' ) {<br />
      var jsonpUrl = options.url.indexOf('?') &gt; -1 ? options.url: options.url +<br />
        '?' + options.jsonp+ '=' + options.jsonpCallback;

      _sendJsonpRequest(jsonpUrl,options.jsonpCallback,options.success);

      return;<br />
    }

     //XMLHttpRequest传参无影响<br />
    var xhr = new (window.XMLHttpRequest || ActiveXObject)('Microsoft.XMLHTTP');

    // get搜索字符串<br />
    var search = '';

    // 将data序列化<br />
    var param= _param(options.data)

    if( options.type === 'GET' ) {<br />
      search = (options.url.indexOf('?') &gt; -1 ? '&amp;' : '?') + param;<br />
      if(!options.cache) {<br />
        search += '&amp;radom='+Math.random();<br />
      }

      param = null;<br />
    }

    xhr.open( options.type, options.url + search, options.async );

    xhr.onreadystatechange = function() {<br />
      if( xhr.readyState == 4 ) {<br />
        if( xhr.status &gt;= 200 &amp;&amp; xhr.status &lt; 300 || xhr.status == 304 ) {<br />
          var text = xhr.responseText;<br />
          // json格式转换<br />
          if(options.dataType == 'json') {<br />
              text = parseJSON(text)<br />
          }

          if( typeof options.success === 'function') {

            options.success(text,xhr.status)<br />
          }

        }else {

          if(typeof options.fail === 'function') {<br />
            options.fail('获取失败', 500)<br />
          }

        }<br />
      }<br />
    }

    xhr.setRequestHeader('content-type',options.contentType);<br />
    // get请求时param时null<br />
    xhr.send(param);

    // 如果设置了超时，就定义<br />
    if(typeof options.timeout === 'number') {<br />
      // ie9+<br />
      if( xhr.timeout ) {<br />
        xhr.timeout = options.timeout;<br />
      }else {<br />
        setTimeout(function() {<br />
          xhr.abort();<br />
        },options.timeout)<br />
      }<br />
    }<br />
  }

}()</pre>
</div>
<p>可以看到，我们很熟悉的xhr代码，在这里，我们需要写一个解析返回字串形成json格式对象的方法parseJSON，类似于jq中的parseJSON方法，如上所示。</p>
<p>我们还需要设置超时代码，如果设置了请求超时，我们就如上定义。</p>
<p>注意：上面代码中，由于懒，设置请求头一行并没有判断是否在post请求下，你可以自己设置~~~。</p>
<h2>结尾</h2>
<p>一个简单的ajax方法就完成了，你是否也完成了呢？如果你懂deferred，你可以尝试着书写为deferred格式，很简单的~~~。</p>
<p>能力有限，水平一般，如有错误，请指正。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gjlw49.html">关于zigbee 网络拓扑节点数量的一点说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ko22jq.html">Google在KDD2013上关于CTR的一篇论文</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mdj2o8.html">iOS开发网络篇&mdash;数据缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q77lkxq.html">PHP的ob&lowbar;start&lpar;&rpar;函数用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96w0j3q.html">JavaScript基础知识汇总</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kx53rq.html">Hibernate框架之关联映射入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mxeykq.html">Dr&period;Kong的艺术品</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mndgxrq.html">Codeforces 475 B Strongly Connected City【DFS】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y5yj3q.html">缓存算法&ndash;LRU</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1z1ne9.html">QTableWidget查找指定项（由github处学习到）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1d7jdq.html">poj2253（最短路小变形）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj4wwlq.html">iOS摇一摇功能、震动功能、简单的摇动动画、生成二维码图片与发送短信等几个功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kdpo49.html">Matlab人脸检測方法（Face Parts Detection）具体解释</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjmy0e9.html">xml和java对象互转：JAXB注解的使用详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjox249.html">使用Dotfuscator混淆你的&period;net程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/96307yn9.html">Android 控件进阶修炼-仿360手机卫士波浪球进度控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9633kyy9.html">【C&num;】自定义容器控件，设置界面控件，支持设计器拖入控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppgwmz9.html">python编码（三）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qx267dd8.html">通过golang 查询impala</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4p26y0q.html">Eclipse Xml编译错误Referenced file contains errors - spring-beans-4&period;0&period;xsd</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/0o8o4pqz.html">Angular2入门系列教程4-服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gmwl97.html">Pivot 和 Unpivot</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdpyzqd.html">和 Thrift 的一场美丽邂逅</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j1j495.html">Android Button的基本使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnvl28r.html">UWP开发之Mvvmlight实践八：为什么事件注销处理要写在OnNavigatingFrom中</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9ppm49x.html">简记用ArcGIS处理某项目需求中数据的步骤</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2mvx87.html">基于开源项目SharpMap的热力图&lpar;HeatLayer&rpar;实现。</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ovopqz.html">【SAP业务模式】之ICS（一）：业务详述</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7geeqe.html">&lbrack;Django&rsqb;用户权限学习系列之User权限基本操作指令</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq43n08z.html">Android下&sol;data&sol;data&sol;&amp;lt&semi;package&lowbar;name&amp;gt&semi;&sol;files读写权限</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
